# -*- coding: utf-8 -*-
"""CNN_Keras_MNIST_Code3.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1AyfCPnGp63caWflOeUoPddASNzZT21EW
"""

from __future__ import print_function
import keras
from keras.models import Sequential
from keras.layers import Dense, Dropout, Flatten,Activation
from keras.layers import Conv2D, MaxPooling2D
import numpy as np
import tensorflow as tf

# Import MNIST data
from tensorflow.examples.tutorials.mnist import input_data
mnist = input_data.read_data_sets("MNIST_data/", one_hot=True)

# Parameters
learning_rate = 0.001 #learning rate or step size for optimization
batch_size = 100 # batch size to input the in batches

# Network Parameters
n_input = 784 # MNIST data input (img shape: 28*28)
n_classes = 10 # MNIST total classes (0-9 digits)
dropout = 0.8 # Dropout, probability to keep units

# (3) Create a sequential model
model = Sequential()

# 1st Convolutional Layer (here you should also define the input shape)
model.add(Conv2D(filters=32, input_shape=(28,28,1), kernel_size=(5,5),strides=(1,1),activation='relu', padding='same'))
# 1st Pooling Layer
model.add(MaxPooling2D(pool_size=(2,2), strides=(2,2), padding='same'))

# 2nd Convolutional Layer
model.add(Conv2D(filters=64, kernel_size=(5,5), strides=(1,1), padding='same',activation='relu'))
# 2nd Pooling Layer
model.add(MaxPooling2D(pool_size=(2,2), strides=(2,2), padding='same'))

# Passing it to a dense layer
model.add(Flatten())
# 1st Dense Layer
model.add(Dense(1024,activation='relu'))
# Add Dropout to prevent overfitting
model.add(Dropout(dropout))
# Output Layer
model.add(Dense(n_classes,activation='softmax'))
model.summary()

model.compile(loss=keras.losses.categorical_crossentropy,
              optimizer=keras.optimizers.Adam(lr=learning_rate),
              metrics=['accuracy'])

X0 = mnist.train.images
X = np.reshape(X0, (55000, 28, 28, 1))
Y  = mnist.train.labels

Xv0 = mnist.validation.images
Xv  = np.reshape(Xv0, (5000, 28, 28, 1))
Yv  = mnist.validation.labels
model.fit(X, Y, batch_size=batch_size,epochs=1,verbose=1,validation_data=(Xv, Yv))#steps_per_epoch= 550,validation_steps =  2

Xt0 = mnist.test.images
Xt0.shape
XT  = np.reshape(Xt0, (10000, 28, 28, 1))
YT  = mnist.test.labels
# Evaluation
score = model.evaluate (x=XT, y=YT, batch_size=batch_size, verbose =0)
print('Test loss:', score[0], 'and Test accuracy:', score[1])