# -*- coding: utf-8 -*-
"""GPU_Implementation_Code2

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/132podbk_osn9V1xsc9g1o9pXG1H1LQsz
"""

import numpy as np
import tensorflow as tf
from datetime import datetime
import time

# Processing Units logs
log_device_placement = True

# Num of multiplications to perform
n = 10
x_dim = 5000
y_dim = 5000

######################################### Example: compute A^n + B^n #######################
# Create random large matrix
A = np.random.rand(x_dim, y_dim).astype('float32')
B = np.random.rand(x_dim, y_dim).astype('float32')

# Create a graph to store results
c1 = []
c2 = []
A.shape

def matpow(M, n):
    if n < 1: #Abstract cases where n < 1
        return M
    else:
        return tf.matmul(M, matpow(M, n-1))

######################################################only cpu #############################
with tf.device('/cpu:0'):
    a = tf.placeholder(tf.float32, [x_dim, y_dim])
    b = tf.placeholder(tf.float32, [x_dim, y_dim])
    # Compute A^n and B^n and store results in c1
    c1.append(matpow(a, n))
    c1.append(matpow(b, n))

with tf.device('/cpu:0'):
  sum = tf.add_n(c1) #Addition of all elements in c1, i.e. A^n + B^n

t1_1 = time.time()
with tf.Session() as sess:
    # Run the op.
    sess.run(sum, {a:A, b:B})
t2_1 = time.time()

######################################################cpu and gpu #############################
with tf.device('/gpu:0'):
    #All operations constructed in this context will be placed on GPU 0.
    a1 = tf.placeholder(tf.float32, [x_dim, y_dim])
    b1 = tf.placeholder(tf.float32, [x_dim, y_dim])
    # Compute A^n and B^n and store results in c1
    c2.append(matpow(a1, n))
    c2.append(matpow(b1, n))

with tf.device('/cpu:0'):
  sum = tf.add_n(c2) #Addition of all elements in c1, i.e. A^n + B^n

config = tf.ConfigProto() # a protocol message to set configurations
config.gpu_options.allow_growth = True #only grow the memory usage as it is needed by the process
config.allow_soft_placement = True # For TensorFlow to automatically choose an existing and supported device to run the operations in case the specified one doesn't exist
config.log_device_placement = True #To find out which devices your operations and tensors are assigned to, create the session with log_device_placement configuration option set to True 

t1_2 = time.time()
with tf.Session(config=config) as sess:
    # Run the op.
    sess.run(sum, {a1:A, b1:B})
t2_2 = time.time()

print("CPU computation time: " + str(t2_1-t1_1))
print("Single GPU computation time: " + str(t2_2-t1_2))